/*
 * This file is part of the QPxTool project.
 * Copyright (C) 2006 Gennady "ShultZ" Kozlov <qpxtool@mail.ru>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

#ifndef __asdb_edit_dialog
#define __asdb_edit_dialog

#include <stdio.h>
#include <stdlib.h>
#include <qpx_mmc.h>
#include <plextor_features.h>
#include <qlistview.h>
#include <qlabel.h>

#include <ui/ASDB_ui.h>

class asdb_edit_dialog : public asdb_edit_dialog_UI
{
	Q_OBJECT

public:
	asdb_edit_dialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
	~asdb_edit_dialog();

    /*$PUBLIC_FUNCTIONS$*/
//public functions:

private:
	int db_act;
	int as_mode;

	void	asdb_redraw();
	QListViewItem* asdb_entry[31];

private slots:
	void	asdb_act_deact();
	void	asdb_act_deact(QListViewItem* Item);
	void	asdb_delete();

	void	as_quick_toggled(bool state);
	void	as_full_toggled(bool state);
	void	db_add_toggled(bool state);
	void	db_replace_toggled(bool state);
	void	asdb_create();

	void	asdb_close();
};

extern	drive_info*	asdb_drive;
#endif //__asdb_edit_dialog
